# coding: utf-8

"""
Binance Derivatives Trading Options REST API

OpenAPI Specification for the Binance Derivatives Trading Options REST API
The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from binance_sdk_derivatives_trading_options.rest_api.models.order_book_response_asks_item import (
    OrderBookResponseAsksItem,
)
from binance_sdk_derivatives_trading_options.rest_api.models.order_book_response_bids_item import (
    OrderBookResponseBidsItem,
)
from typing import Set
from typing_extensions import Self


class OrderBookResponse(BaseModel):
    """
    OrderBookResponse
    """  # noqa: E501

    t: Optional[StrictInt] = Field(default=None, alias="T")
    u: Optional[StrictInt] = None
    bids: Optional[List[OrderBookResponseBidsItem]] = None
    asks: Optional[List[OrderBookResponseAsksItem]] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["T", "u", "bids", "asks"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def is_array(cls) -> bool:
        return False

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderBookResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set(
            [
                "additional_properties",
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in bids (list)
        _items = []
        if self.bids:
            for _item_bids in self.bids:
                if _item_bids:
                    _items.append(_item_bids.to_dict())
            _dict["bids"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in asks (list)
        _items = []
        if self.asks:
            for _item_asks in self.asks:
                if _item_asks:
                    _items.append(_item_asks.to_dict())
            _dict["asks"] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderBookResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "T": obj.get("T"),
                "u": obj.get("u"),
                "bids": (
                    [
                        OrderBookResponseBidsItem.from_dict(_item)
                        for _item in obj["bids"]
                    ]
                    if obj.get("bids") is not None
                    else None
                ),
                "asks": (
                    [
                        OrderBookResponseAsksItem.from_dict(_item)
                        for _item in obj["asks"]
                    ]
                    if obj.get("asks") is not None
                    else None
                ),
            }
        )
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj
