# coding: utf-8

"""
Binance Derivatives Trading Options REST API

OpenAPI Specification for the Binance Derivatives Trading Options REST API
The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Set
from typing_extensions import Self


class QueryOptionOrderHistoryResponseInner(BaseModel):
    """
    QueryOptionOrderHistoryResponseInner
    """  # noqa: E501

    order_id: Optional[StrictInt] = Field(default=None, alias="orderId")
    symbol: Optional[StrictStr] = None
    price: Optional[StrictStr] = None
    quantity: Optional[StrictStr] = None
    executed_qty: Optional[StrictStr] = Field(default=None, alias="executedQty")
    fee: Optional[StrictStr] = None
    side: Optional[StrictStr] = None
    type: Optional[StrictStr] = None
    time_in_force: Optional[StrictStr] = Field(default=None, alias="timeInForce")
    reduce_only: Optional[StrictBool] = Field(default=None, alias="reduceOnly")
    post_only: Optional[StrictBool] = Field(default=None, alias="postOnly")
    create_time: Optional[StrictInt] = Field(default=None, alias="createTime")
    update_time: Optional[StrictInt] = Field(default=None, alias="updateTime")
    status: Optional[StrictStr] = None
    reason: Optional[StrictStr] = None
    avg_price: Optional[StrictStr] = Field(default=None, alias="avgPrice")
    source: Optional[StrictStr] = None
    client_order_id: Optional[StrictStr] = Field(default=None, alias="clientOrderId")
    price_scale: Optional[StrictInt] = Field(default=None, alias="priceScale")
    quantity_scale: Optional[StrictInt] = Field(default=None, alias="quantityScale")
    option_side: Optional[StrictStr] = Field(default=None, alias="optionSide")
    quote_asset: Optional[StrictStr] = Field(default=None, alias="quoteAsset")
    mmp: Optional[StrictBool] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = [
        "orderId",
        "symbol",
        "price",
        "quantity",
        "executedQty",
        "fee",
        "side",
        "type",
        "timeInForce",
        "reduceOnly",
        "postOnly",
        "createTime",
        "updateTime",
        "status",
        "reason",
        "avgPrice",
        "source",
        "clientOrderId",
        "priceScale",
        "quantityScale",
        "optionSide",
        "quoteAsset",
        "mmp",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def is_array(cls) -> bool:
        return False

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QueryOptionOrderHistoryResponseInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set(
            [
                "additional_properties",
            ]
        )

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QueryOptionOrderHistoryResponseInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "orderId": obj.get("orderId"),
                "symbol": obj.get("symbol"),
                "price": obj.get("price"),
                "quantity": obj.get("quantity"),
                "executedQty": obj.get("executedQty"),
                "fee": obj.get("fee"),
                "side": obj.get("side"),
                "type": obj.get("type"),
                "timeInForce": obj.get("timeInForce"),
                "reduceOnly": obj.get("reduceOnly"),
                "postOnly": obj.get("postOnly"),
                "createTime": obj.get("createTime"),
                "updateTime": obj.get("updateTime"),
                "status": obj.get("status"),
                "reason": obj.get("reason"),
                "avgPrice": obj.get("avgPrice"),
                "source": obj.get("source"),
                "clientOrderId": obj.get("clientOrderId"),
                "priceScale": obj.get("priceScale"),
                "quantityScale": obj.get("quantityScale"),
                "optionSide": obj.get("optionSide"),
                "quoteAsset": obj.get("quoteAsset"),
                "mmp": obj.get("mmp"),
            }
        )
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj
